unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.ExtDlgs, Vcl.ExtCtrls,
  Vcl.StdCtrls, System.UITypes;

type
  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    RGBtoHSVbtn: TButton;
    RadioGroup1: TRadioGroup;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    ColorControlBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure RGBtoHSVbtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure ColorControlBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray = ^TPrgbarry;                     // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

var
  InBitmap        : TBitmap;                    // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                    // \[X摜TCY

// RGB  HSV ϊ[`@Hsu F Saturation ʓx Value x
procedure RGBtoHSV(Red, Green, Blue: Integer; var Hue, Saturation: Double; var Value: Integer);
var
  CMax, CMin, CG: Integer;
begin
  Hue := 0;
  CMax := Max(Red, Max(Green, Blue)); // ől
  CMin := Min(Red, Min(Green, Blue)); // ŏl
  Value := CMax;                      // őlx̒l
  // Value(x) = 0 ̎
  if Value = 0 then begin
    Saturation := 0;
    Value      := 0;
    exit;
  end;
  // Value(x) <> 0 ̎
  Saturation := (CMax - CMin) / CMax;                 // ʓx̌vZ
  if CMax <> CMin then begin                          // F̌vZ CMAXCMINꍇ H(F) = 0
    CG := CMax - CMin;
    if Red = CMax then Hue := 60 * (Green - Blue) / CG
    else
      if Green = CMax then Hue := 60 * (Blue - Red) / CG + 120
      else
        if Blue = CMax then Hue := 60 * (Red - Green) / CG + 240;
    if Hue < 0 then Hue := Hue + 360;
  end;
end;

// HSV  RGB ϊ[`@Hsu F Saturation ʓx Value x
procedure HSVtoRGB(Hue, Saturation: Double; Value: Integer; var Red, Green, Blue: Byte);
var
  P, Q, T, Hi : Integer;
  F           : Double;
begin
  if Saturation = 0 then        // ʓx[̏ꍇ̓O[ OFlł
  begin
    Red   := Value;
    Green := Value;
    Blue  := Value;
  end
  else
  begin // Saturation <> 0
    Hi := Trunc(Hue / 60);        // 60Ŋ̒l
    F  := Frac(Hue / 60);         // 60Ŋ̒l
    P  := Round(Value * (1 - Saturation));
    Q  := Round(Value * (1 - Saturation * F));
    T  := Round(Value * (1 - Saturation * (1 - F)));
    if P < 0 then P := 0;
    if P > 255 then P:= 255;
    if Q < 0 then Q := 0;
    if Q > 255 then Q:= 255;
    if T < 0 then T := 0;
    if T > 255 then T:= 255;
    case Hi of
      0:  begin
            Red   := Value;
            Green := T;
            Blue  := P;
          end;
      1:  begin
            Red   := Q;
            Green := Value;
            Blue  := P;
          end;
      2:  begin
            Red   := P;
            Green := Value;
            Blue  := T;
          end;
      3:  begin
            Red   := P;
            Green := Q;
            Blue  := Value;
          end;
      4:  begin
            Red   := T;
            Green := P;
            Blue  := Value;
          end;
      5:  begin
            Red   := Value;
            Green := P;
            Blue  := Q;
          end;
    end;
  end;
end;

// RGB  HSV ϊ \
procedure TForm1.RGBtoHSVbtnClick(Sender: TObject);
var
  i, j        : integer;
  D, V        : integer;
  hf, Sf      : Double;
  pb, pbi     : Prgbarray;
begin
  for i := 0 to Gheight - 1 do begin
    pbi := Inbitmap.ScanLine[i];
    pb := OutBitmap.ScanLine[i];
    D := 0;
    for j := 0 to GWidth - 1 do begin
      RGBtoHSV(Pbi[j].rgbtRed, pbi[j].rgbtGreen, pbi[j].rgbtBlue, Hf, Sf, V); // HSV ϊ
      case RadioGroup1.ItemIndex of                           // WI{^̈ʒuŕ\ύX
        0 : D := Round(Hf * 255 / 360);                       // F
        1 : D := Round(Sf * 255);                             // ʓx
        2 : D := V;                                           // x
      end;
      pb[j].rgbtRed   := D;                                   // OFlZbgăO[\
      pb[j].rgbtGreen := D;
      pb[j].rgbtBlue  := D;
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                         // 摜\
end;

// ColorConrol
procedure TForm1.ColorControlBtnClick(Sender: TObject);
var
  Hue, sat, value : Double;
  k               : integer;
  Hi, sati        : Double;
  valuei          : Integer;
  X, Y            : Integer;
  Pb, Pbi         : Prgbarray;
begin
  val(LabeledEdit1.Text, Hue, K);
  if K <> 0 then begin
    Application.MessageBox('Fpx̓͒lɌ肪܂B','F',0);
    exit;
  end;
  if abs(hue) > 360 then begin
    Application.MessageBox('Fpxl傫܂B','F',0);
    exit;
  end;
  val(LabeledEdit2.Text, sat, K);
  if K <> 0 then begin
    Application.MessageBox('ʓxGainW̓͒lɌ肪܂B','ʓx',0);
    exit;
  end;
//  if sat < 0 then begin
//    Application.MessageBox('ʓxGainW̓[ȉł͂܂B','ʓx',0);
//    exit;
//  end;
  val(LabeledEdit3.Text, value, K);
  if K <> 0 then begin
    Application.MessageBox('xGainW̓͒lɌ肪܂B','x',0);
    exit;
  end;
  if value < 0 then begin
    Application.MessageBox('xGainW̓[ȉł͂܂B','x',0);
    exit;
  end;
  for Y := 0 to GHeight - 1 do begin
    pbi := Inbitmap.ScanLine[Y];
    pb  := OutBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      RGBtoHSV(pbi[X].rgbtRed, pbi[X].rgbtGreen, pbi[X].rgbtBlue, hi, Sati, valuei);  // R G B  H(F) S(ʓx) V(x)ɕϊ
      hi := hi + Hue;                                         // F̏
      if hi < 0   then hi := hi + 360;
      if hi > 360 then hi := hi - 360;
      sati := sati * sat;                                     // ʓx̏
      if sati > 1 then sati := 1;
      valuei := Round(valuei * value);                        // x̏
      if valuei > 255 then valuei := 255;
      HSVtoRGB(hi, sati, valuei, pb[X].rgbtRed, pb[X].rgbtGreen, pb[X].rgbtBlue);     // H S V  R G B ɕϊ
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                         // 摜\
  FileSaveBtn.Enabled := True;
end;

// t@C̎wI[v
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InBitmap.Width    := GWidth;                          // 摜
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width   := GWidth;                          // o͉摜
        OutBitmap.Height  := GHeight;                         // o͉摜
        image1.Picture.Bitmap := InBitmap;                    // 摜\
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  RGBtoHSVbtn.Enabled := True;                                // {^Cl[u
  ColorControlBtn.Enabled := True;
end;

// t@C֕ۑ
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                             // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                 // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                               // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');    // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                          // gqo
  if not WFormatSet then begin                                              // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                       // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                           // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                 // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                  // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                                // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                  // t@C̏o
  finally                                                                   // XE3,XE4̏ꍇ̓AV[v}XLOQƂĂ
    WIC.Free;                                                               // TWicImage
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top := (Screen.Height - Height) div 2;                      // \ʒuݒ
  Left := (Screen.Width - Width) div 2;
  InBitmap      := TBitmap.Create;                            // ͉摜p
  OutBitmap     := TBitmap.Create;                            // o͉摜p
  InBitmap.PixelFormat    := pf24bit;                         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;                         // 24rbgJ[ɐݒ
  RGBtoHSVbtn.Enabled := False;                               // {^fBXGu
  FileSaveBtn.Enabled := False;
  ColorControlBtn.Enabled := False;
end;

// Irbg}bv̔j
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
